public class Evalue{// une instance de la classe Evalue est en fait un noeud de l'arborescence.
  boolean[] pris;  // pris represente une solution realisable.
  int maj; // evaluation par exces du noeud: maj=I.somp(pris)
  int min; // evaluation par default: min=poids de la solution optimale du sous-probleme relaxe continument.
  int sep; // sep est l'indice de l'objet pris en partie
  static Instance I;  // probleme a resoudre
  static int nbobj;   // nombre d'objets
  static Evalue best; // meilleure solution realisable trouvee jusqu'a present
  static boolean[] fixe;// fixe[i] indique que pris[i] ne doit pas changer.
       
  public Evalue(boolean[] Pris){
    pris = new boolean[nbobj];
    for(int i=0;i<nbobj;i++) pris[i]=fixe[i] && Pris[i]; // A priori un objet non fixe n'est pas pris.
    int U=I.somu(pris), P=min=I.somp(pris), u, p;
    if(U<I.utiliteMin) for(sep=0;sep<nbobj;sep++) if(!fixe[sep]) // tant que la solution (pris) n'est pas réalisable
    { pris[sep]=true;   // on ajoute un a un les objets non fixes (dans l'ordre des poids/utilite croissants)
      U+=u=I.lesObjets.get(sep).getUtil();
      P+=p=I.lesObjets.get(sep).getPoids();
      if(U>=I.utiliteMin) {min=P-p*(U-I.utiliteMin)/u; break;} // si U est trop grand l'objet sep est pris en partie 
    }
    maj=P;  // =I.somp(pris)
    if(U<I.utiliteMin) min=Integer.MAX_VALUE;// meme en prenant tous les objets possibles U est trop faible: noeud vide.
    if(best==null || maj<best.maj) best=this; // pris est la meilleure solution realisable connue
  }
  void separe()  // parcours recursif en profondeur d'abord
  { if(min>=best.maj) return;  // noeud inutile
    pris[sep]^=fixe[sep]=true; Evalue a=new Evalue(pris); // on separe this en a et b en forcant la prise
    pris[sep]^=          true; Evalue b=new Evalue(pris); // ou l'exclusion de l'objet d'indice sep.
    if(a.min<b.min) { a.separe(); b.separe(); } // On explore d'abord le plus prometteur des deux fils.
    else            { b.separe(); a.separe(); } // Avec de la chance on n'aura pas besoin d'explorer l'autre.
    fixe[sep]=false;           // fixe[sep] et pris[sep] sont remis a leur valeur initiale.
  }
  public static Solution cherche(Instance i){
    I=i; nbobj=I.lesObjets.taille(); best=null; fixe=new boolean[nbobj];// initialisation des 4 variables membres statiques
    for(int j=0;j<nbobj;j++) fixe[j]=false; // A la racine de l'arborescence, aucun objet n'est force.
    (new Evalue(fixe)).separe();       // parcours de toute l'arborescence
    return new Solution(best.pris);
  }  
}
