import java.util.TreeMap;
public class Instance {
    public int nbObjets;
    public ListeObjets lesObjets;
    public int utiliteMin;
    
    public Instance(int nb, ListeObjets obj, int umin){
        nbObjets=nb;     // Nombre des objets pouvant entrer dans le sac
        utiliteMin=umin; // utilite minimale
        lesObjets=obj;   // Liste des objets pouvant entrer dans le sac
        this.lesObjets.trie();
    }
    
    public void afficheInstance(){
       System.out.println("Nombre Objets : " + nbObjets+" Utilite Minimale " +utiliteMin+"\n");
       System.out.println("Numero   " + lesObjets.affichelNum());
       System.out.println("Poids    "+ lesObjets.affichelPoids());
       System.out.println("Utilites " + lesObjets.affichelUtil());
    }

    @Override
    public String toString(){
       return "Instance de Taille: "+nbObjets+" avec utilite Min: "+utiliteMin+"\n"+lesObjets.toString();
    }
    public int somu(boolean t[])
    { int s=0;
      for(int i=0;i<nbObjets;i++) if(t[i]) s+=lesObjets.get(i).getUtil();
      return s;
    }
    public int somp(boolean t[])
    { int s=0;
      for(int i=0;i<nbObjets;i++) if(t[i]) s+=lesObjets.get(i).getPoids();
      return s;
    }
    static public String SetToString(boolean[] t)
    { String s="[ ";
      for(int i=0;i<t.length;i++) if(t[i]) s+=i+" ";
      return s+"]";
    }
    public String SetUPToString(boolean[] x)
    { return SetToString(x)+" u="+somu(x)+" p="+somp(x); }

    Solution RechercheTabou(int l)
    { class CompArrayBool implements java.util.Comparator<boolean[]>
      { @Override
        public int compare(boolean[] s, boolean[] t)
        { for(int i=0;i<nbObjets;i++) if(s[i]!=t[i]) return t[i]? -1 :1;
          return 0;
        }
      }
      TreeMap<boolean[],Integer> tabou=new TreeMap<>(new CompArrayBool());
      int n=nbObjets, c=0, cM=0, py, pm,  pM;       // Poids respectifs des
      boolean[] x=new boolean[n], y,  m=x, M=x;     // solutions y, m et M.
      java.util.Random alea=new java.util.Random(); // générateur de nombres entiers aléatoires
      Integer o;
      for(int i=0;i<n;i++) x[i]=alea.nextInt(2)>0;  // x est une solution aléatoire
      while(somu(x)<utiliteMin) x[alea.nextInt(n)]=true; // x est augmentée aléatoirement pour être réalisable
      for(pM=somp(M);tabou.put(x=m,c++)==null;)     // Tant que c'est possible, x est remplacé par son meilleur voisin m
      { pm=Integer.MAX_VALUE;                       // pm=infini car m est inconnu.
        System.out.println(c+" "+SetUPToString(x));
        for(int i=0;i<n;i++)                          // Tout
        { y=java.util.Arrays.copyOf(x,n); y[i]=!y[i]; // voisin y de x
          if(somu(y)>=utiliteMin && (py=somp(y))<pm && ((o=tabou.get(y))==null || o<c-l)) // réalisable, meilleur que m et non tabou
          { m=y; pm=py; }                             // prend la place de m 
        }                              // m est donc le meilleur voisin de x réalisable et non tabou trouvé jusque là.
        if(pm<pM) { M=m; pM=pm; cM=c+1; }// M est la meilleure de toutes les solutions réalisables trouvées jusque là.
      }
      System.out.println(cM+"/"+c+" "+pM);
      return new Solution(M);
    }
    Solution ProgrammationDynamique()
    { int F[][]=new int[nbObjets+1][utiliteMin+1], infini=Integer.MAX_VALUE/2;
      for(int U=1;U<=utiliteMin;U++) F[0][U]=infini;
      F[0][0]=0;
      for(int i=0;i<nbObjets;i++)
      { int u=lesObjets.get(i).getUtil(), p=lesObjets.get(i).getPoids(), a[]=F[i], b[]=F[i+1], x;
        if(u>utiliteMin) u=utiliteMin;
        for(int U=0;U<=utiliteMin     ;U++) b[U]=a[U];
        for(int U=u;U<=utiliteMin     ;U++) if((x=a[U-u]+p)<b[U]) b[U]=x;
        for(int d=0,U =utiliteMin;d<=u;d++) if((x=a[U-d]+p)<b[U]) b[U]=x;
      }
      boolean[] x=new boolean[nbObjets];
      for(int i=0;i<nbObjets;i++) x[i]=false;
      int U=utiliteMin;
      if(F[nbObjets][U]==infini) return new Solution(x); // pas de solutions
      for(int i=nbObjets;i>0;)
      { int u=lesObjets.get(--i).getUtil(), p=lesObjets.get(i).getPoids(), a[]=F[i], b[]=F[i+1];
        if(u> utiliteMin) u=utiliteMin;
        if(U==utiliteMin) for(int d=0;d<=u;d++) if(a[U-d]+p==b[U]) {U+=u-d; break;}
        if(U> utiliteMin || b[U]!=a[U]) {x[i]=true; U-=u; }
      }
      return new Solution(x);
    }
}
